//////////////////////////////////////////////////
//// Exercice 3: Résolution numérique d'un problème de diffusion
//////////////////////////////////////////////////

// Objectif résoudre l'EDP
// du/dt = Kx d2u/dx2

clear;clc;clf;

disp('Exercice 3')

// Conditions et paramètres initiaux
pi=2*acos(0);       // Pi defini via arccos
p=0;                // Borne inf du domaine
q=1;                // Borne sup du domaine
t=0;                // Definition de T0
Kx=1.0;             // Coefficient de diffusion
N=51;               // Discretisation spatiale
dx=(q-p)/(N-1);     // dx
x = p: dx : q;      // Echantillonage
u0=zeros(1,N);      // vecteur pour stocker les conditions initiales
u0=sin(pi*x);       // set des conditions initiales
initialu=u0;
ntimesteps=300;     // nombre de pas de simulation
dt=dx*dx/(2*Kx);    // critere de van neumann pour garantir la stabilité
dt=0.9*dt;          // ponderé pour assurer stabilité

u=zeros(1,N+2);

// Algorithme
for counter=1:ntimesteps
    t=t+dt; 
    u0=[0 u0 0]; // definition du nouveau u0 avec CL
    for i=2:N+1
        // TODO: schéma 
    end
    u0=u(2:N+1); // copie de Uo pour la prochaine iteration
end 


exact=exp(-Kx*pi*pi*t)*sin(pi*x); // solution exacte
plot(x,initialu,x,exact,'b+',x,u(2:N+1),'ro')
xlabel('x')
ylabel('concentration u')
title('Diffusion: (--) Profil initial / (o) simule (+) exacte')

disp('Fin Exercice 3')
